local cList = {
	["WARRIOR"]		= "Warrior",
	["MAGE"]		= "Mage",
	["ROGUE"]		= "Rogue",
	["DRUID"]		= "Druid",
	["HUNTER"]		= "Hunter",
	["SHAMAN"]	 	= "Shaman",
	["PRIEST"]		= "Priest",
	["WARLOCK"]		= "Warlock",
	["PALADIN"]		= "Paladin",
	["DEATHKNIGHT"]	= "Death Knight",
	["MONK"]		= "Monk",
	["DEMONHUNTER"]	= "Demon Hunter",
};
local sList = {
	["DEATHKNIGHT"]	=	{["Blood"] = 250, ["Frost"] = 251, ["Unholy"] = 252,},
	["DEMONHUNTER"]	=	{["Havoc"] = 577, ["Vengeance"] = 581,},
	["DRUID"]		=	{["Balance"] = 102, ["Feral"] = 103, ["Guardian"] = 104, ["Restoration"] = 105},
	["HUNTER"]		=	{["Beast Mastery"] = 253, ["Marksmanship"] = 254, ["Survival"] = 255},
	["MAGE"]		=	{["Arcane"] = 62, ["Fire"] = 63, ["Frost"] = 64},
	["MONK"]		=	{["Brewmaster"] = 268, ["Mistweaver"] = 270, ["Windwalker"] = 269},
	["PALADIN"]		=	{["Holy"] = 65, ["Protection"] = 66, ["Retribution"] = 70},
	["PRIEST"]		=	{["Discipline"] = 256, ["Holy"] = 257, ["Shadow"] = 258},
	["ROGUE"]		=	{["Assassination"] = 259, ["Outlaw"] = 260, ["Subtlety"] = 261},
	["SHAMAN"]		=	{["Elemental"] = 262, ["Enhancement"] = 263, ["Restoration"] = 264},
	["WARLOCK"]		=	{["Affliction"] = 265, ["Demonology"] = 266, ["Destruction"] = 267},
	["WARRIOR"]		=	{["Arms"] = 71, ["Fury"] = 72, ["Protection"] = 73},
}
PTV = LibStub("AceAddon-3.0"):NewAddon("PvPTemplates", "AceConsole-3.0")
-- Use AceConsole-3.0 to register a Chat Command
PTV:RegisterChatCommand("pt", "ChatCommand")

-- Show the GUI if no input is supplied, otherwise handle the chat input.
function PTV:ChatCommand(input)
  -- Assuming "MyOptions" is the appName of a valid options table
  if not input or input:trim() == "" then
	self.PvPTemplateWindow:Show()
	self.classSelector:SetValue(select(2,UnitClass("player")))
	self.specSelector:SetList({}) -- set the specSelector list (table of id=text_to_display)
	for i,_ in pairs(self.sList[self.classSelector:GetValue()]) do
		self.specSelector:AddItem(i,i)
	end
	local _, s = GetSpecializationInfo(GetSpecialization())
	self.specSelector:SetValue(s)
	PTV:updateData()
  else
  end
end
local function round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end
function PTV:updateData()
  local selecterC = PTV.classSelector:GetValue()
  local first = string.sub(selecterC, 1,1)
  local rest = string.sub(selecterC, 2,string.len(selecterC))
  PTV.tg:SetTitle(PTV.specSelector:GetValue().." "..first:upper()..rest:lower())
  local tb = PTV.templateBox
  local fetchedTemplate = C_PvP.GetGlobalPvpScalingInfoForSpecID(PTV.sList[PTV.classSelector:GetValue()][PTV.specSelector:GetValue()])
  local sBuilder = ""
  for _,i in pairs(fetchedTemplate) do
	local v = round(i.value*100, 0)
	local n = i.name:gsub(" %(Multiplicative%)", ""):gsub(" %(Override%)", "")
	if string.find(n, "Additive") then
		n = n:gsub(" %(Additive, max level only%)", "")
		sBuilder = sBuilder..n..": |cff99ff33"..v.." ilvl|r\n\n"
	elseif string.find(n, "Mod Damage Done") then
		sBuilder = sBuilder..n..": |cff99ff33"..i.value.."%|r\n\n"
	elseif string.find(n, "Mod Power Regen") then
		sBuilder = sBuilder..n..": |cff99ff33"..i.value.."|r\n\n"
	else
		sBuilder = sBuilder..n..": |cff99ff33"..v.."%|r\n\n"
	end
  end
  tb:SetText(sBuilder)
end
local AceGUI = LibStub("AceGUI-3.0")
-- Create a container frame
local PvPTemplateWindow = AceGUI:Create("Frame", "PvPTemplateWindow")
PvPTemplateWindow:Hide()
PvPTemplateWindow:SetTitle("PvP Template Viewer")
PvPTemplateWindow:SetStatusText("By Jax")
PvPTemplateWindow:SetLayout("Flow")
PvPTemplateWindow:SetWidth(250)
PvPTemplateWindow:EnableResize(false)



-- Create a dropdown
local classSelector = AceGUI:Create("Dropdown")
classSelector:SetFullWidth(true)
classSelector:SetList(cList) -- set the classSelector list (table of id=text_to_display)
classSelector:SetValue(select(2,UnitClass("player"))) -- current player class is checked initialy
classSelector:SetCallback("OnValueChanged", function(choice)
	local self = PTV
	self.specSelector:SetList({}) -- set the specSelector list (table of id=text_to_display)
	local sel
	for i,_ in pairs(self.sList[self.classSelector:GetValue()]) do
		sel = i
		self.specSelector:AddItem(i,i)
	end
	self.specSelector:SetValue(sel)
	PTV:updateData()
end )
-- create label for class
local classLabel = AceGUI:Create("Heading")
classLabel:SetText("Select Class")
classLabel:SetFullWidth(true)

PvPTemplateWindow:AddChild(classLabel)
PvPTemplateWindow:AddChild(classSelector)
-- create label for spec
local specLabel = AceGUI:Create("Heading")
specLabel:SetText("Select Spec")
specLabel:SetFullWidth(true)

PvPTemplateWindow:AddChild(specLabel)


local tGroup = AceGUI:Create("InlineGroup")
tGroup:SetLayout("Fill")
tGroup:SetFullHeight(true)
local cIcon = AceGUI:Create("Icon")
cIcon:SetImage("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES", unpack(CLASS_ICON_TCOORDS[classSelector:GetValue()]))
cIcon:SetImageSize(35,35)
cIcon:SetWidth(45)
--tGroup:AddChild(cIcon)

local templateBox = AceGUI:Create("Label")
templateBox:SetFontObject(GameFontNormalSmall)
templateBox:SetColor(1,0.8,0)
PTV.templateBox = templateBox
tGroup:AddChild(templateBox)

-- Create a dropdown
local specSelector = AceGUI:Create("Dropdown")
specSelector:SetFullWidth(true)
specSelector:SetList({}) -- set the specSelector list (table of id=text_to_display)
local specD
for i,_ in pairs(sList[classSelector:GetValue()]) do
	specD = i
	specSelector:AddItem(i,i)
end
specSelector:SetCallback("OnValueChanged", function(choice)
	PTV:updateData()
end )

specSelector:SetValue(specD) -- current player spec is checked initialy
PvPTemplateWindow:AddChild(specSelector)

tGroup:SetFullWidth(true)
tGroup:SetTitle("Stat Template")
PvPTemplateWindow:AddChild(tGroup)

PTV.PvPTemplateWindow = PvPTemplateWindow;
PTV.classSelector = classSelector;
PTV.specSelector = specSelector;
PTV.sList = sList;
PTV.cList = cList;
PTV.tg = tGroup
PTV:updateData()

ChatFrame1:AddMessage("|cffff0000PvPTemplates|r: " .. "open with /pt")

